# heise.tcl v1.3 by domsen <domsen@domsen.org> (c)2oo2
#
# comments? bugs? ideas? plz mail me :)
#
# das tcl liest die news von heise aus und msgt sie dem user.
# benutzt wird http://www.heise.de/newsticker und es werden
# die news des aktuellen tages wiedergegeben.
#
# ".heisenews" fr die letzten x news des tages, wobei x die 
# im tcl eingestellte anzahl von heiselimit ist, "" steht fr
# alle newslines, ansonsten muss ein limit angegeben werden.
# 10 ist empfehlenswert, die newslines werden durchnummeriert
# fr den command .heiselink
#
# ".heisenews all" gibt alle news des tages wieder
#
# ".heiselink <x>" msgt die url der newsline nummer x
#
# newspost gibt an ob neue newslines in die channels gepostet 
# werden sollen, 1 fr ja, 0 fr nein 
#
# heisechans sind die channels in denen die commands zur
# verfgung stehen, "" steht fr alle channels, ansonsten
# einfach eine liste der chans also zb "#chan1 #chan2"
#
# year steht fr das aktuelle jahr prefixed mit einem punkt,
# wird zur auswertung unbedingt bentigt.
#
# heiselimit sind die anzahl der newslines die maximal
# gepostet werden um floods zu vermeiden
#
# isheisehub legt fest ob der bot newshub ist oder nicht, das
# leaf tcl ist auch auf www.domsen.org verfgbar.
#
# heiseleafs sind die nicks der leafbots auf denen das leaf tcl
# luft
#
# man htte dieses tcl auch simpler coden knnen durch den
# gebrauch von regusbs und wget, aber das wre zu einfach
# gewesen da man die regexpr-strings aus den php backends
# benutzen knnte - wo bleibt da die herausforderung. wget
# ist auerdem nicht auf allen shells erlaubt, also habe ich
# mich fr lynx entschieden. die tcl http lib wollte ich auch
# nicht benutzen, da ich gerne auf fremden externen code
# vollkommen verzichte :-)
#
####### config ######################

set heisetrigger ".heisenews"
set searchtrigger ".heiselink"
set year ".2002"
set heiselimit "10"
set heisechans ""
set newspost "1"
set isheisehub "1"
set heiseleafs ""

####### ende der config #############

bind pub - $heisetrigger pub_heise
bind msg - $heisetrigger msg_heise
bind msg - $searchtrigger hmsg_search
bind pub - $searchtrigger hpub_search
bind time - "?0 * * * *" heisecheck


proc sendheisenews { arg } {
global heiseleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $heiseleafs] [string tolower $bot]] != -1)} {
putbot $bot "heise: $arg"
}}}


proc heisecheck { nick uhost hand chan arg } {
global year heisechans newspost isheisehub
if {$newspost == 1 } {

set hdlfile "heise.hdl"
set lastnews "none"
if {[file exists $hdlfile]} {
putlog "heisenews: suche nach neuer newsline"
set temp [open "heise.hdl" r]
set counter 0
set hehe " "
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first $year $zeile] != -1) && ([string first "]" $zeile] == -1) } {
incr counter }
if {($counter == "1") && ($zeile != "") && ([string first $year $zeile] == -1) } {
incr counter
set lastnews [string range $zeile [expr [string first "]" $zeile] +1 ] [string length $zeile]]
}}
close $temp }
# ript neu
exec lynx -preparsed -dump -width=200 http://www.heise.de/newsticker > heise.hdl
set temp [open "heise.hdl" r]
set counter 0
set hehe " "
if {$lastnews == "none" } { 
putlog "heise: headlinefile created"
return 0 
}
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first $year $zeile] != -1) && ([string first "]" $zeile] == -1) } {
incr counter }
if {($counter == "1") && ($zeile != "") && ([string first $year $zeile] == -1) } {
incr counter
set neunews [string range $zeile [expr [string first "]" $zeile] +1 ] [string length $zeile]]
if {$lastnews == $neunews} { incr counter }
if {$lastnews != $neunews} {
putlog "heise: neue newsline"
if { $isheisehub == "1" } { sendheisenews $neunews }
foreach chan [channels] {
if { $heisechans == "" } {
putserv "privmsg $chan :(neue heise newsline) $neunews" }
if { $heisechans != "" } {
if {([lsearch -exact [string tolower $heisechans] [string tolower $chan]] != -1)} {
putserv "privmsg $chan :(neue heise newsline) $neunews"
}}}}}}
close $temp
}}


proc hmsg_search { nick uhost hand arg } {
global year
exec lynx -preparsed -dump -width=200 http://www.heise.de/newsticker > heise.temp
set temp [open "heise.temp" r]
set newslinenr 0
set counter 0
set linknr 0
set checker "duh"
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first $year $zeile] != -1) && ([string first "]" $zeile] == -1) } {
incr counter }
if {($counter == "1") && ($zeile != "")&& ([string first $year $zeile] == -1) } {
incr newslinenr }
if { $arg == $newslinenr } {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.heise.de/newsticker/data/"
set checker "ok"
}
if {($checker == "ok") && ([string first $linknr $zeile ] != -1)} {
set hyperlink [string range $zeile 6 [string length $zeile]]
putserv "privmsg $nick :$hyperlink"
putlog "heisenews: link search by $nick"
set checker "duh"
}}}





proc hpub_search { nick uhost hand chan arg } {
global year heisechans
if {([lsearch -exact [string tolower $heisechans] [string tolower $chan]] != -1) || ($heisechans == "")} {
global year
exec lynx -preparsed -dump -width=200 http://www.heise.de/newsticker > heise.temp
set temp [open "heise.temp" r]
set newslinenr 0
set counter 0
set linknr 0
set checker "duh"
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first $year $zeile] != -1) && ([string first "]" $zeile] == -1) } {
incr counter }
if {($counter == "1") && ($zeile != "")&& ([string first $year $zeile] == -1) } {
incr newslinenr }
if { $arg == $newslinenr } {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.heise.de/newsticker/data/"
set checker "ok"
}
if {($checker == "ok") && ([string first $linknr $zeile ] != -1)} {
set hyperlink [string range $zeile 6 [string length $zeile]]
putserv "notice $nick :$hyperlink"
putlog "heisenews: link search by $nick on $chan"
set checker "duh"
}}}}





proc msg_heise { nick uhost hand arg } {
global year heiselimit
exec lynx -preparsed -dump -width=200 http://www.heise.de/newsticker > heise.temp
set temp [open "heise.temp" r]
set counter 0
set newslinenr 0
set hehe " "
if {($arg == "") && ($heiselimit != "")} {
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first $year $zeile] != -1) && ([string first "]" $zeile] == -1)  } {
incr counter }
if {($counter == "1") && ($zeile != "")  && ($zeile != "  ")} {
if { [string first $year $zeile] != -1 } {
set date [string range $zeile 3 [string length $zeile]]
putserv "privmsg $nick :die letzten $heiselimit heise news fr den $date"
} else {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
if {$zeile != ""} {
set newsline [string range $zeile [expr [string first "]" $zeile] +1 ] [string length $zeile]]
set linknr [string range $zeile 1 2]
if {$newslinenr < $heiselimit } {
incr newslinenr 
putserv "privmsg $nick :$newslinenr $newsline"
}}}}}
close $temp
putlog "heisenews: sent last $heiselimit newslines to $nick"
return 0 }
if {($arg == "all") || ($heiselimit == "") } {
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first $year $zeile] != -1) && ([string first "]" $zeile] == -1) } {
incr counter }
if {($counter == "1") && ($zeile != "")  && ($zeile != "  ")} {
if { [string first $year $zeile] != -1 } {
set date [string range $zeile 3 [string length $zeile]]
putserv "privmsg $nick :heise news fr den $date"
} else {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
if {$zeile != ""} {
set newsline [string range $zeile [expr [string first "]" $zeile] +1 ] [string length $zeile]]
set linknr [string range $zeile 1 2]
incr newslinenr 
putserv "privmsg $nick :$newslinenr $newsline"
}}}}
close $temp
putlog "heisenews: sent all newslines to $nick"
}}



proc pub_heise { nick uhost hand chan arg } {
global year heiselimit
exec lynx -preparsed -dump -width=200 http://www.heise.de/newsticker > heise.temp
set temp [open "heise.temp" r]
set counter 0
set newslinenr 0
set hehe " "
if {($arg == "") && ($heiselimit != "")} {
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first $year $zeile] != -1) && ([string first "]" $zeile] == -1) } {
incr counter }
if {($counter == "1") && ($zeile != "")  && ($zeile != "  ")} {
if { [string first $year $zeile] != -1 } {
set date [string range $zeile 3 [string length $zeile]]
putserv "notice $nick :die letzten $heiselimit heise news fr den $date"
} else {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
if {$zeile != ""} {
set newsline [string range $zeile [expr [string first "]" $zeile] +1 ] [string length $zeile]]
set linknr [string range $zeile 1 2]
if {$newslinenr < $heiselimit } {
incr newslinenr 
putserv "notice $nick :$newslinenr $newsline"
}
}}}}
close $temp
putlog "heisenews: sent last $heiselimit newslines to $nick"
return 0 }
#
if {($arg == "all" || ($heiselimit == "")) } {
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first $year $zeile] != -1) && ([string first "]" $zeile] == -1) } {
incr counter }
if {($counter == "1") && ($zeile != "")  && ($zeile != "  ")} {
if { [string first $year $zeile] != -1 } {
set date [string range $zeile 3 [string length $zeile]]
putserv "notice $nick :heise news fr den $date"
} else {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
if {$zeile != ""} {
set newsline [string range $zeile [expr [string first "]" $zeile] +1 ] [string length $zeile]]
set linknr [string range $zeile 1 2]
incr newslinenr 
putserv "notice $nick :$newslinenr $newsline"
}}}}
close $temp
putlog "heisenews: sent all newslines to $nick on $chan"
}}


putlog "*** heise.tcl v1.3 by domsen succesfully loaded"

#[EOF]